      subroutine bldxu(deg,xupt,yupt,wupt,nxupt)
      implicit none
c
c     build acos(Xu points) on [-1,1]^2 
c     left-right, bottom-up
c
      integer deg,nxupt
c
c     deg   (i) degree 
c     nxupt (o) number of Xu points
c
      double precision pi
      parameter (pi=3.141592653589793d0)
      double precision xupt(*),yupt(*),wupt(*)
c     xupt  (o) first coord. of Xu points
c     yupt  (o) second coord. of Xu points
c
      integer i,j,itemp0,deg2
      double precision rtemp0
      intrinsic mod,cos
      if (mod(deg,2).ne.0) then
         write(6,*) 'deg must be even.'
         stop
      end if   
      itemp0=deg**2
c      itemp0=1
      rtemp0=pi/deg
      deg2=deg-2
      nxupt=0
c      i=0
      do j=1,deg2+1,2
         nxupt=nxupt+1
         xupt(nxupt)=0.0d0
c         wupt(nxupt)=1.d0/itemp0
         wupt(nxupt)=.5d0/itemp0
      end do
      do i=2,deg2,2
         do j=1,deg2+1,2
            nxupt=nxupt+1
            xupt(nxupt)=i*rtemp0
c            wupt(nxupt)=2.d0/itemp0;
            wupt(nxupt)=1.d0/itemp0;
         end do
      end do
c      i=deg
      do j=1,deg2+1,2
         nxupt=nxupt+1
         xupt(nxupt)=pi
c         wupt(nxupt)=1.d0/itemp0
         wupt(nxupt)=.5d0/itemp0
      end do
c      j=0
      do i=1,deg2+1,2
         nxupt=nxupt+1
         xupt(nxupt)=i*rtemp0
c         wupt(nxupt)=1.d0/itemp0
         wupt(nxupt)=.5d0/itemp0
      end do
      do j=2,deg2,2
         do i=1,deg2+1,2
            nxupt=nxupt+1
            xupt(nxupt)=i*rtemp0
c            wupt(nxupt)=2.d0/itemp0
            wupt(nxupt)=1.d0/itemp0
         end do
      end do
c      j=deg
      do i=1,deg2+1,2
         nxupt=nxupt+1
         xupt(nxupt)=i*rtemp0
c         wupt(nxupt)=1.d0/itemp0
         wupt(nxupt)=.5d0/itemp0
      end do
      do i=1,nxupt/2
         yupt(i)=xupt(nxupt/2+i)
         yupt(nxupt/2+i)=xupt(i)
      end do   
      return
      end
